<template>
	<el-dialog :title="titleMap[mode]" v-model="visible" :width="500" destroy-on-close :close-on-click-modal="false" @closed="$emit('closed')">
		<el-form :model="form" :rules="rules" :disabled="mode=='show'" ref="dialogForm" label-width="100px" label-position="left">
			<el-form-item label="头像" prop="avatar">
				<sc-upload v-model="form.avatar" title="头像" />
			</el-form-item>
			<el-form-item label="用户名" prop="username">
				<el-input v-model="form.username" placeholder="用户名" clearable />
			</el-form-item>
			<el-form-item label="用户昵称" prop="nickname">
				<el-input v-model="form.nickname" placeholder="用户昵称" clearable />
			</el-form-item>
			<el-form-item label="手机号码" prop="mobile">
				<el-input v-model="form.mobile" placeholder="手机号码" clearable />
			</el-form-item>
			<el-form-item label="邀请人" prop="invite_uid">
				<el-input v-model="form.invite_uid" placeholder="邀请人" clearable />
			</el-form-item>
			<el-form-item label="用户密码" prop="password">
				<el-input v-model="form.password" placeholder="用户密码" clearable />
			</el-form-item>
			<el-form-item label="状态" prop="status">
				<el-select v-model="form.status" placeholder="请选择状态" clearable>
					<el-option v-for="(item, index) in [{label: '启用', value: 1}, {label: '禁用', value: 0}]" :key="index" :label="item.label" :value="item.value" />
				</el-select>
			</el-form-item>
		</el-form>
		<template #footer>
			<el-button @click="visible=false;isSaveing=false" >取 消</el-button>
			<el-button v-if="mode!='show'" type="primary" :loading="isSaveing" @click="submit()">保 存</el-button>
		</template>
	</el-dialog>
</template>

<script>
export default {
	emits: ['success', 'closed'],
	data() {
		return {
			mode: "add",
			titleMap: {
				add: '新增用户',
				edit: '编辑用户',
				show: '查看'
			},
			visible: false,
			isSaveing: false,
			//表单数据
			form: { username: ''},
			//验证规则
			rules: {
				username: [{required: true, message: '请输入用户名'}],
				nickname: [{required: true, message: '请输入用户名称'}]
			}
		}
	},
	mounted() {
	},
	methods: {
		//显示
		open(mode='add'){
			this.mode = mode;
			this.visible = true;
			return this
		},
		//表单提交方法
		submit(){
			this.$refs.dialogForm.validate(async (valid) => {
				if (valid) {
					this.isSaveing = true;
					var res = {};
					if(this.mode == 'add'){
						res = await this.$API.member.lists.add.post(this.form);
					}else{
						res = await this.$API.member.lists.edit.post(this.form);
					}

					this.isSaveing = false;
					if(res.code == 1){
						this.$emit('success', this.form, this.mode)
						this.visible = false;
						this.$message.success("操作成功")
					}else{
						this.$alert(res.message, "提示", {type: 'error'})
					}
				}else{
					return false;
				}
			})
		},
		//表单注入数据
		setData(data){
			this.form = data
		}
	}
}
</script>

<style>
</style>
